#include <p18f4580.h>
#include <usart.h>
#include <delays.h>
#include <stdio.h>
#include <stdlib.h>
//#include <math.h>

#pragma config OSC= HS
#pragma config WDT=OFF
#pragma config LVP=OFF

#define Trig PORTBbits.RB3
#define Echo PORTBbits.RB2

void T0Delay10us(void);
void T0Delay5ms(void);
void uart(void);
void Call_Init_PIC (void);
void Call_Init_USART (void);
void sendPulse(void);

//unsigned int distance=0;
unsigned short distance=0;
unsigned int distancecm;


void main(void)
{
Call_Init_PIC ();
Call_Init_USART ();
//uart();
while(1)
{

sendPulse();
while(Echo == 1);
TMR1H= 0;
TMR1L= 0;
T1CON = 0x01;
while(Echo == 0);
distance = (TMR1H<<8) + TMR1L;
T1CON = 0x00;
while (BusyUSART());
distance = (distance/58)*20;;  //store result
sprintf(distancecm,"%d",distance); 
putrsUSART(distancecm); 
//distance =(TMR1L | (TMR1H<<8));
//T1CON = 0x00;                            
//distance = (distance/58)*20;
//distance = (distance/58);
//printf("Distance = %d",distance);
//sprintf(distancecm,"%u",distance); 
//putsUSART(distancecm); 


//printf("cm\n");
Delay10KTCYx(255); 
//PIR1bits.TMR1IF=0;
T0Delay5ms(); 
}
}

void Call_Init_PIC (void)
{
TRISBbits.TRISB3=0;
TRISBbits.TRISB2=1;
}

/*
void uart(void)
{
TXSTA=0B00100000;
SPBRG=32;
TRISCbits.RC6=0;
RCSTAbits.SPEN=1;
}
*/

void sendPulse(void)
	{
	Trig=1;
	T0Delay10us();
	Trig=0;
	}


void T0Delay10us()
	{
	T0CON=0x08;
	TMR0H=0XFF;
	TMR0L=0XCE;
	T0CONbits.TMR0ON=1;
	while(INTCONbits.TMR0IF==0);
	T0CONbits.TMR0ON=0;
	INTCONbits.TMR0IF=0;
	}


void T0Delay5ms()
	{
	T0CON=0x08;
	TMR0H=0X9E;
	TMR0L=0X58;
	T0CONbits.TMR0ON=1;
	while(INTCONbits.TMR0IF==0);
	T0CONbits.TMR0ON=0;
	INTCONbits.TMR0IF=0;
	}

void Call_Init_USART ()
{

OpenUSART( USART_TX_INT_OFF &
USART_RX_INT_OFF &
USART_ASYNCH_MODE &
USART_EIGHT_BIT &
USART_CONT_RX &
USART_BRGH_HIGH,
31); //Bit per second:9600 / Data bit: 8 / Partiy bit : None / Stop bit : 1 / Flow control : None

}